\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Bijection where

open import VFP.Equality public
\end{code}

Injective functions.
%
\begin{code}
infix 2 _↪_
record _↪_ (A B : Set) : Set where
  field to  : A -> B
        fro : B -> A
        fro∘to≡id : ∀ x -> fro (to x) ≡ x
open _↪_ public
\end{code}

Bijection (isomorphism).
%
\begin{code}
infix 2 _≅_
record _≅_ (A B : Set) : Set where
  field to  : A -> B
        fro : B -> A
        fro∘to≡id : ∀ x -> fro (to x) ≡ x
        to∘fro≡id : ∀ x -> to (fro x) ≡ x
open _≅_ public
\end{code}

Unicode table:

↪    \hookrightarrow    U-21aa  RIGHTWARDS ARROW WITH HOOK
≅    \cong \~=          U-2245  APPROXIMATELY EQUAL TO
○    \ci                U-25cb  WHITE CIRCLE
∘    \comp or \circ or \o
