Equational reasoning using Wim Feijen's proof format.

    proof
      expr1
    ≡⟨ why? ⟩ 
      expr2
    ≡⟨ why? ⟩ 
      expr3
    ∎

    expr1
  ≡⟨ ? ⟩ 
    expr2
  ∎

\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Equality.Reasoning where

open import VFP.Equality.Properties public

infix  0 proof_
infixr 1 ≡-link
infix  2 _∎

proof_ : {A : Set} {x y : A} → x ≡ y → x ≡ y
proof x≡y = x≡y

syntax ≡-link x q p = x ≡⟨ p ⟩ q
≡-link : {A : Set} (x : A) {y z : A} → y ≡ z → x ≡ y → x ≡ z
x ≡⟨ x≡y ⟩ y≡z = transitive x≡y y≡z

_∎ :  {A : Set} (x : A) → x ≡ x
x ∎ = reflexive

by-definition : {A : Set} {x : A} -> x ≡ x
by-definition = reflexive 
\end{code}
