\begin{code}
{-# OPTIONS --without-K --safe #-}

module VFP.Function.Equality.Properties where

open import VFP.Function.Equality public

private variable
  A B C : Set
\end{code}

-------------------------------------------------------------------------------

\begin{code}
⩧-reflexive : {f : A -> B} -> f ⩧ f
⩧-reflexive = λ a -> reflexive

⩧-symmetric : {f g : A -> B} -> f ⩧ g -> g ⩧ f
⩧-symmetric f⩧g = λ a → symmetric (f⩧g a)

⩧-transitive : {f g h : A -> B} -> f ⩧ g -> g ⩧ h -> f ⩧ h
⩧-transitive f⩧g g⩧h = λ a → transitive (f⩧g a) (g⩧h a)
\end{code}


\begin{code}
⟦_⟧ : (f : A -> B) -> f ⩧ f
⟦ f ⟧ = λ a -> reflexive

infixr 9 _⟦∘⟧_ _⟦；⟧_

_⟦∘⟧_ : {g g′ : B → C} → {f f′ : A → B} → g ⩧ g′ -> f ⩧ f′ -> g ∘ f ⩧ g′ ∘ f′
_⟦∘⟧_ {g′ = g′} {f = f} g⩧g′ f⩧f′ = λ a → transitive (g⩧g′ (f a)) (congruent g′ (f⩧f′ a)) 

_⟦；⟧_ : {f f′ : A → B} → f ⩧ f′ -> {g g′ : B → C} → g ⩧ g′ -> f ； g ⩧ f′ ； g′
_⟦；⟧_ {f = f} f⩧f′ {g′ = g′} g⩧g′ = λ a → transitive (g⩧g′ (f a)) (congruent g′  (f⩧f′ a))
\end{code}

-------------------------------------------------------------------------------

<<equivalent>>
\begin{code}
extensional-equality-to : ∀ (f g : A -> B) -> (∀ x -> f x ≡ g x) -> (∀ a b -> a ≡ b -> f a ≡ g b)
extensional-equality-to f g p a .a ≡-reflexive = p a

extensional-equality-fro : ∀ (f g : A -> B) -> (∀ a b -> a ≡ b -> f a ≡ g b) -> (∀ x -> f x ≡ g x)
extensional-equality-fro f g q x = q x x ≡-reflexive
\end{code}

-------------------------------------------------------------------------------
