Advanced properties (uniqueness of inequality proofs) that need Axiom K.

\begin{code}
--{-# OPTIONS --without-K --safe #-}
{-# OPTIONS --safe #-}

module VFP.Natural.Order.Properties.Advanced where

open import VFP.Natural.Order.Properties public
open import VFP.Equality.Properties public
open import VFP.Logic
\end{code}

private variable
  k m n : ℕ

-------------------------------------------------------------------------------

Uniqueness of proofs.

\begin{code}
≼-unique : ∀ {m n} -> (p : m ≼ n) -> (q : m ≼ n) -> p ≡ q
≼-unique (inl reflexive) (inl reflexive) = reflexive   -- here Axiom K is needed!
≼-unique (inl reflexive) (inr y) = ex-falso-quodlibet (≺-irreflexive y)
≼-unique (inr y) (inl reflexive) = ex-falso-quodlibet (≺-irreflexive y)
≼-unique (inr y) (inr y₁) = congruent inr (≺-unique y y₁)
\end{code}

\begin{code}
≺₁-unique : ∀ {m n} -> (p : m ≺₁ n) -> (q : m ≺₁ n) -> p ≡ q
≺₁-unique one one = reflexive   -- here Axiom K is needed!
≺₁-unique one (succ q) with not-equal₁ _ _ q reflexive
... | ()
≺₁-unique (succ p) one with not-equal₁ _ _ p reflexive
... | ()
≺₁-unique (succ p) (succ q) with ≺₁-unique p q
... | reflexive = reflexive
\end{code}
