-------------------------------------------------------------------------------

\begin{code}
--{-# OPTIONS --allow-unsolved-metas #-}
--{-# OPTIONS --without-K --safe #-}

module VFP.Serialise.Ad-hoc where

open import VFP.Serialise using (Bits; [] ; 𝟢 ; 𝟣 ; Bush ; Leaf ; Fork)
open import VFP.Logic
open import VFP.Maybe

-- private variable
\end{code}

-------------------------------------------------------------------------------

begin{code}
data Bush : Set where
  Leaf  : Bush
  Fork  : Bush -> Bush -> Bush
end{code}

An ad-hoc decoder to illustrate the problem with Agda's termination checker.

<<decode>>
\begin{code}
{-# TERMINATING #-}
decode : Bits -> Maybe (Bush × Bits)
decode []      = undefined
decode (𝟢 bs)  = return (Leaf , bs)
decode (𝟣 bs)  = do  (t ,  bs′)  <- decode bs
                     (u ,  bs″)  <- decode bs′
                     return (Fork t u , bs″)
\end{code}

-------------------------------------------------------------------------------
