-------------------------------------------------------------------------------

\begin{code}
--{-# OPTIONS --allow-unsolved-metas #-}
{-# OPTIONS --without-K --safe #-}

module VFP.Serialise.Indexed.Ad-hoc where

open import VFP.Bits
open import VFP.Logic
open import VFP.Maybe
open import VFP.Natural.Non-Strict-Order

-- private variable
\end{code}

-------------------------------------------------------------------------------

\begin{code}
data Bush : Set where
  Leaf  : Bush
  Fork  : Bush -> Bush -> Bush
\end{code}

An ad-hoc decoder to illustrate how course-of-values recursion is
implemented.

<<decode>>
\begin{code}
decode : (i : ℕ) -> ∀ {j} -> i ≽ j -> Bits j -> Maybe (Bush × Bits≼ j)
decode i         (zero)      []      = undefined
decode (succ i)  (succ i≽j)  (𝟢 bs)  = return (Leaf , bs such-that succ-n≽n)
decode (succ i)  (succ i≽j)  (𝟣 bs)  =
  do   (t ,  bs′  such-that j≽k)  <- decode i i≽j                      bs
       (u ,  bs″  such-that k≽m)  <- decode i (≽-transitive i≽j j≽k)  bs′
       return (Fork t u , bs″ such-that ≽-transitive succ-n≽n (≽-transitive j≽k k≽m))
\end{code}

-------------------------------------------------------------------------------
